console.log("background.js loaded");

browser.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === "GET_CONTEXT_STACK") {
    browser.tabs.sendMessage(message.tabId, message)
      .then((res) => {
        console.log("RESPONSE", res);
        sendResponse(res);
      })
      .catch((err) => {
        console.log("Error sending message to content script:", err);
        sendResponse({ error: err });
      });
    // browser.tabs.query({ active: true, currentWindow: true }).then((tabs) => {
    //   if (tabs.length) {
    //   }
    // });
    return true;
  } else if (message.type === "UPDATE_CONTEXT_VALUE") {
    browser.tabs.sendMessage(message.tabId, message).then(sendResponse);
    // browser.tabs.query({ active: true, currentWindow: true }).then((tabs) => {
    //   if (tabs.length) {
    //   }
    // });
    return true;
  }
});

let devtoolsPort = null;

browser.runtime.onConnect.addListener((port) => {
  if (port.name === "devtools") {
    devtoolsPort = port;
    console.log("Devtools panel connected.");

    // port.onMessage.addListener((msg) => {
    //   console.log("Received message from devtools panel:", msg);
    // });

    port.onDisconnect.addListener(() => {
      devtoolsPort = null;
    });
  }
});

// Relay messages from content scripts to the devtools panel.
browser.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === "PAGE_LOADED") {
    console.log("Background received PAGE_LOADED message from content script.");
    if (devtoolsPort) {
      devtoolsPort.postMessage({ type: "PAGE_LOADED" });
    }
  }
});
